Index: cpukit/libnetworking/rtems/rtems_glue.c
===================================================================
--- cpukit/libnetworking/rtems/rtems_glue.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/libnetworking/rtems/rtems_glue.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -373,20 +373,18 @@
 #ifdef RTEMS_FAST_MUTEX
 	Thread_queue_Context queue_context;
-	Thread_Control *executing;
+	Status_Control status;
 	if (!the_networkSemaphore)
 		rtems_panic ("rtems-net: network sema obtain: network not initialised\n");
 	_Thread_queue_Context_initialize(&queue_context, NULL);
 	_ISR_lock_ISR_disable(&queue_context.Lock_context);
-	executing = _Thread_Executing;
-	_CORE_mutex_Seize (
+	status = _CORE_mutex_Seize (
 		&the_networkSemaphore->Core_control.mutex,
-		executing,
+		_Thread_Executing,
 		1,		/* wait */
 		0,		/* forever */
 		&queue_context
 		);
-	if (executing->Wait.return_code)
-		rtems_panic ("rtems-net: can't obtain network sema: %d\n",
-                 executing->Wait.return_code);
+	if (status != STATUS_SUCCESSFUL)
+		rtems_panic ("rtems-net: can't obtain network sema: %d\n", status);
 #else
 	rtems_status_code sc;
@@ -407,5 +405,5 @@
 #ifdef RTEMS_FAST_MUTEX
 	Thread_queue_Context queue_context;
-	CORE_mutex_Status status;
+	Status_Control status;
 
 	if (!the_networkSemaphore)
@@ -417,5 +415,5 @@
 		&queue_context
 		);
-	if (status != CORE_MUTEX_STATUS_SUCCESSFUL)
+	if (status != STATUS_SUCCESSFUL)
 		rtems_panic ("rtems-net: can't release network sema: %i\n");
 #else
Index: cpukit/posix/Makefile.am
===================================================================
--- cpukit/posix/Makefile.am	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/Makefile.am	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -75,5 +75,5 @@
     src/barrierattrinit.c src/barrierattrsetpshared.c src/pbarrier.c \
     src/pbarrierdestroy.c src/pbarrierinit.c \
-    src/pbarriertranslatereturncode.c src/pbarrierwait.c
+    src/pbarrierwait.c
 
 ## CANCEL_C_FILES
@@ -100,5 +100,5 @@
     src/mqueuereceive.c src/mqueuerecvsupp.c src/mqueuesend.c \
     src/mqueuesendsupp.c src/mqueuesetattr.c src/mqueuetimedreceive.c \
-    src/mqueuetimedsend.c src/mqueuetranslatereturncode.c \
+    src/mqueuetimedsend.c \
     src/mqueueunlink.c
 
@@ -111,5 +111,5 @@
     src/mutexgetprioceiling.c src/mutexinit.c src/mutexlock.c \
     src/mutexlocksupp.c src/mutexsetprioceiling.c src/mutextimedlock.c \
-    src/mutextranslatereturncode.c src/mutextrylock.c src/mutexunlock.c
+    src/mutextrylock.c src/mutexunlock.c
 
 ## PTHREAD_C_FILES
@@ -176,11 +176,10 @@
     src/prwlocktryrdlock.c src/prwlocktrywrlock.c src/prwlockunlock.c \
     src/prwlockwrlock.c src/rwlockattrdestroy.c src/rwlockattrgetpshared.c \
-    src/rwlockattrinit.c src/rwlockattrsetpshared.c \
-    src/prwlocktranslatereturncode.c
+    src/rwlockattrinit.c src/rwlockattrsetpshared.c
 
 ## SEMAPHORE_C_FILES
 libposix_a_SOURCES += src/semaphore.c src/semaphorecreatesupp.c \
     src/semaphoredeletesupp.c \
-    src/semaphoretranslatereturncode.c src/semaphorewaitsupp.c \
+    src/semaphorewaitsupp.c \
     src/semclose.c src/semdestroy.c src/semgetvalue.c src/seminit.c \
     src/semopen.c src/sempost.c src/semtimedwait.c src/semtrywait.c \
@@ -189,5 +188,5 @@
 ## SPINLOCK_C_FILES
 libposix_a_SOURCES += src/pspin.c src/pspindestroy.c src/pspininit.c \
-    src/pspinlock.c src/pspinlocktranslatereturncode.c src/pspintrylock.c \
+    src/pspinlock.c src/pspintrylock.c \
     src/pspinunlock.c
 
Index: cpukit/posix/include/rtems/posix/barrierimpl.h
===================================================================
--- cpukit/posix/include/rtems/posix/barrierimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/include/rtems/posix/barrierimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -37,18 +37,4 @@
 
 extern Objects_Information _POSIX_Barrier_Information;
-
-/**
- * @brief POSIX translate barrier return code.
- * 
- * This routine translates SuperCore Barrier status codes into the
- * corresponding POSIX ones.
- *
- * @param[in] the_barrier_status is the SuperCore status.
- *
- * @return the corresponding POSIX status
- */
-int _POSIX_Barrier_Translate_core_barrier_return_code(
-  CORE_barrier_Status  the_barrier_status
-);
 
 /**
Index: cpukit/posix/include/rtems/posix/mqueueimpl.h
===================================================================
--- cpukit/posix/include/rtems/posix/mqueueimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/include/rtems/posix/mqueueimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -150,12 +150,4 @@
 
 /**
- *  @brief POSIX Message Queue Translate Score Return Code
- *
- */
-int _POSIX_Message_queue_Translate_core_message_queue_return_code(
-  uint32_t   the_message_queue_status
-);
-
-/**
  *  @brief POSIX Message Queue Remove from Namespace
  */
Index: cpukit/posix/include/rtems/posix/muteximpl.h
===================================================================
--- cpukit/posix/include/rtems/posix/muteximpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/include/rtems/posix/muteximpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -41,10 +41,4 @@
 
 /**
- *  This array contains a mapping from Score Mutex return codes to
- *  POSIX return codes.
- */
-extern const int _POSIX_Mutex_Return_codes[CORE_MUTEX_STATUS_LAST + 1];
-
-/**
  *  @brief POSIX Mutex Allocate
  *
@@ -84,40 +78,4 @@
 
 /**
- * @brief Convert Score mutex status codes into POSIX status values
- *
- * A support routine which converts core mutex status codes into the
- * appropriate POSIX status values.
- *
- * @param[in] the_mutex_status is the mutex status code to translate
- *
- * @retval 0 Mutex status code indicates the operation completed successfully.
- * @retval EBUSY Mutex status code indicates that the operation unable to 
- *         complete immediately because the resource was unavailable.
- * @retval EDEADLK Mutex status code indicates that an attempt was made to
- *         relock a mutex for which nesting is not configured.
- * @retval EPERM Mutex status code indicates that an attempt was made to 
- *         release a mutex by a thread other than the thread which locked it.
- * @retval EINVAL Mutex status code indicates that the thread was blocked
- *         waiting for an operation to complete and the mutex was deleted.
- * @retval ETIMEDOUT Mutex status code indicates that the calling task was
- *         willing to block but the operation was unable to complete
- *         within the time allotted because the resource never became
- *         available.
- */
-RTEMS_INLINE_ROUTINE int _POSIX_Mutex_Translate_core_mutex_return_code(
-  CORE_mutex_Status  the_mutex_status
-)
-{
-  /*
-   *  Internal consistency check for bad status from SuperCore
-   */
-  #if defined(RTEMS_DEBUG)
-    if ( the_mutex_status > CORE_MUTEX_STATUS_LAST )
-      return EINVAL;
-  #endif
-  return _POSIX_Mutex_Return_codes[the_mutex_status];
-}
-
-/**
  *  @brief POSIX Mutex Get (Interrupt Disable)
  *
Index: cpukit/posix/include/rtems/posix/posixapi.h
===================================================================
--- cpukit/posix/include/rtems/posix/posixapi.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/include/rtems/posix/posixapi.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -24,4 +24,6 @@
 #include <rtems/score/apimutex.h>
 #include <rtems/score/objectimpl.h>
+#include <rtems/score/threadimpl.h>
+#include <rtems/seterr.h>
 
 /**
@@ -59,4 +61,27 @@
   _Assert( (size_t) error < RTEMS_ARRAY_SIZE( _POSIX_Get_by_name_error_table ) );
   return _POSIX_Get_by_name_error_table[ error ];
+}
+
+RTEMS_INLINE_ROUTINE int _POSIX_Get_error( Status_Control status )
+{
+  return STATUS_GET_POSIX( status );
+}
+
+RTEMS_INLINE_ROUTINE int _POSIX_Get_error_after_wait(
+  const Thread_Control *executing
+)
+{
+  return _POSIX_Get_error( _Thread_Wait_get_status( executing ) );
+}
+
+RTEMS_INLINE_ROUTINE int _POSIX_Zero_or_minus_one_plus_errno(
+  Status_Control status
+)
+{
+  if ( status == STATUS_SUCCESSFUL ) {
+    return 0;
+  }
+
+  rtems_set_errno_and_return_minus_one( _POSIX_Get_error( status ) );
 }
 
Index: cpukit/posix/include/rtems/posix/rwlockimpl.h
===================================================================
--- cpukit/posix/include/rtems/posix/rwlockimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/include/rtems/posix/rwlockimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -39,27 +39,4 @@
 
 /**
- * @brief POSIX translate core RWLock return code.
- *
- * This routine translates SuperCore RWLock status codes into the
- * corresponding POSIX ones.
- *
- *
- * @param[in] the_RWLock_status is the SuperCore status.
- *
- * @return the corresponding POSIX status
- * @retval 0 The status indicates that the operation completed successfully.
- * @retval EINVAL The status indicates that the thread was blocked waiting for
- * an operation to complete and the RWLock was deleted.
- * @retval EBUSY This status indicates that the RWLock was not 
- * immediately available.
- * @retval ETIMEDOUT This status indicates that the calling task was 
- * willing to block but the operation was unable to complete within
- * the time allotted because the resource never became available.
- */
-int _POSIX_RWLock_Translate_core_RWLock_return_code(
-  CORE_RWLock_Status  the_RWLock_status
-);
-
-/**
  * @brief Allocate a RWLock control block.
  *
Index: cpukit/posix/include/rtems/posix/semaphoreimpl.h
===================================================================
--- cpukit/posix/include/rtems/posix/semaphoreimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/include/rtems/posix/semaphoreimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -34,10 +34,4 @@
  */
 extern Objects_Information _POSIX_Semaphore_Information;
-
-/**
- *  This defines the mapping from Score status codes to POSIX return codes.
- */
-extern const int
-  _POSIX_Semaphore_Return_codes[CORE_SEMAPHORE_STATUS_LAST + 1];
 
 RTEMS_INLINE_ROUTINE POSIX_Semaphore_Control *
@@ -109,25 +103,4 @@
   Watchdog_Interval    timeout
 );
-
-/**
- *  @brief POSIX Semaphore Translate Score to POSIX Return Codes
- *
- *  A support routine which converts core semaphore status codes into the
- *  appropriate POSIX status values.
- */
-RTEMS_INLINE_ROUTINE int
-_POSIX_Semaphore_Translate_core_semaphore_return_code(
-  CORE_semaphore_Status  the_semaphore_status
-)
-{
-  /*
-   *  Internal consistency check for bad status from SuperCore
-   */
-  #if defined(RTEMS_DEBUG)
-    if ( the_semaphore_status > CORE_SEMAPHORE_STATUS_LAST )
-      return EINVAL;
-  #endif
-  return _POSIX_Semaphore_Return_codes[the_semaphore_status];
-}
  
 /**
Index: cpukit/posix/include/rtems/posix/spinlockimpl.h
===================================================================
--- cpukit/posix/include/rtems/posix/spinlockimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/include/rtems/posix/spinlockimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -36,18 +36,4 @@
 
 extern Objects_Information _POSIX_Spinlock_Information;
-
-/**
- * @brief Translate core spinlock status code.
- *
- * This routine translates SuperCore Spinlock status codes into the
- * corresponding POSIX ones.
- * 
- * @param[in] the_spinlock_status is the SuperCore status.
- *
- * @return the corresponding POSIX status
- */
-int _POSIX_Spinlock_Translate_core_spinlock_return_code(
-  CORE_spinlock_Status  the_spinlock_status
-);
 
 /**
Index: cpukit/posix/src/condwaitsupp.c
===================================================================
--- cpukit/posix/src/condwaitsupp.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/condwaitsupp.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,6 +21,8 @@
 #include <rtems/posix/condimpl.h>
 #include <rtems/posix/muteximpl.h>
+#include <rtems/posix/posixapi.h>
 #include <rtems/score/assert.h>
 #include <rtems/score/statesimpl.h>
+#include <rtems/score/status.h>
 #include <rtems/score/threaddispatch.h>
 
@@ -37,7 +39,7 @@
   POSIX_Mutex_Control               *the_mutex;
   Thread_queue_Context               queue_context;
-  int                                status;
-  int                                mutex_status;
-  CORE_mutex_Status                  core_mutex_status;
+  int                                error;
+  int                                mutex_error;
+  Status_Control                     status;
   Per_CPU_Control                   *cpu_self;
   Thread_Control                    *executing;
@@ -85,5 +87,4 @@
 
   if ( !already_timedout ) {
-    executing->Wait.return_code = 0;
     _Thread_queue_Enqueue_critical(
       &the_cond->Wait_queue.Queue,
@@ -92,19 +93,15 @@
       STATES_WAITING_FOR_CONDITION_VARIABLE,
       timeout,
-      ETIMEDOUT,
       &queue_context.Lock_context
     );
   } else {
     _POSIX_Condition_variables_Release( the_cond, &queue_context );
-    executing->Wait.return_code = ETIMEDOUT;
+    executing->Wait.return_code = STATUS_TIMEOUT;
   }
 
   _ISR_lock_ISR_disable( &queue_context.Lock_context );
-  core_mutex_status = _CORE_mutex_Surrender(
-    &the_mutex->Mutex,
-    &queue_context
-  );
-  _Assert( core_mutex_status == CORE_MUTEX_STATUS_SUCCESSFUL );
-  (void) core_mutex_status;
+  status = _CORE_mutex_Surrender( &the_mutex->Mutex, &queue_context );
+  _Assert( status == STATUS_SUCCESSFUL );
+  (void) status;
 
   /*
@@ -115,5 +112,5 @@
   _Thread_Dispatch_enable( cpu_self );
 
-  status = (int) executing->Wait.return_code;
+  error = _POSIX_Get_error_after_wait( executing );
 
   /*
@@ -125,6 +122,6 @@
    */
 
-  if ( status == EINTR ) {
-    status = 0;
+  if ( error == EINTR ) {
+    error = 0;
   }
 
@@ -133,9 +130,9 @@
    */
 
-  mutex_status = pthread_mutex_lock( mutex );
-  if ( mutex_status != 0 ) {
+  mutex_error = pthread_mutex_lock( mutex );
+  if ( mutex_error != 0 ) {
     return EINVAL;
   }
 
-  return status;
+  return error;
 }
Index: cpukit/posix/src/mqueuerecvsupp.c
===================================================================
--- cpukit/posix/src/mqueuerecvsupp.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/mqueuerecvsupp.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/posix/mqueueimpl.h>
+#include <rtems/posix/posixapi.h>
 
 #include <fcntl.h>
@@ -49,4 +50,5 @@
   bool                         do_wait;
   Thread_Control              *executing;
+  Status_Control               status;
 
   the_mq = _POSIX_Message_queue_Get( mqdes, &queue_context );
@@ -96,5 +98,5 @@
    */
   executing = _Thread_Executing;
-  _CORE_message_queue_Seize(
+  status = _CORE_message_queue_Seize(
     &the_mq->Message_queue,
     executing,
@@ -112,10 +114,6 @@
   }
 
-  if ( executing->Wait.return_code != CORE_MESSAGE_QUEUE_STATUS_SUCCESSFUL ) {
-    rtems_set_errno_and_return_minus_one(
-      _POSIX_Message_queue_Translate_core_message_queue_return_code(
-        executing->Wait.return_code
-      )
-    );
+  if ( status != STATUS_SUCCESSFUL ) {
+    rtems_set_errno_and_return_minus_one( _POSIX_Get_error( status ) );
   }
 
Index: cpukit/posix/src/mqueuesendsupp.c
===================================================================
--- cpukit/posix/src/mqueuesendsupp.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/mqueuesendsupp.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -46,5 +46,5 @@
   POSIX_Message_queue_Control *the_mq;
   Thread_queue_Context         queue_context;
-  CORE_message_queue_Status    msg_status;
+  Status_Control               status;
   bool                         do_wait;
   Thread_Control              *executing;
@@ -93,5 +93,5 @@
    */
   executing = _Thread_Executing;
-  msg_status = _CORE_message_queue_Submit(
+  status = _CORE_message_queue_Submit(
     &the_mq->Message_queue,
     executing,
@@ -103,13 +103,4 @@
     &queue_context
   );
-
-  if ( msg_status != CORE_MESSAGE_QUEUE_STATUS_SUCCESSFUL ) {
-    rtems_set_errno_and_return_minus_one(
-      _POSIX_Message_queue_Translate_core_message_queue_return_code(
-        msg_status
-      )
-    );
-  }
-
-  return 0;
+  return _POSIX_Zero_or_minus_one_plus_errno( status );
 }
Index: cpukit/posix/src/mutexlocksupp.c
===================================================================
--- cpukit/posix/src/mutexlocksupp.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/mutexlocksupp.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/posix/muteximpl.h>
+#include <rtems/posix/posixapi.h>
 
 THREAD_QUEUE_OBJECT_ASSERT( POSIX_Mutex_Control, Mutex.Wait_queue );
@@ -31,5 +32,5 @@
   POSIX_Mutex_Control  *the_mutex;
   Thread_queue_Context  queue_context;
-  Thread_Control       *executing;
+  Status_Control        status;
 
   the_mutex = _POSIX_Mutex_Get( mutex, &queue_context );
@@ -39,14 +40,11 @@
   }
 
-  executing = _Thread_Executing;
-  _CORE_mutex_Seize(
+  status = _CORE_mutex_Seize(
     &the_mutex->Mutex,
-    executing,
+    _Thread_Executing,
     blocking,
     timeout,
     &queue_context
   );
-  return _POSIX_Mutex_Translate_core_mutex_return_code(
-    (CORE_mutex_Status) executing->Wait.return_code
-  );
+  return _POSIX_Get_error( status );
 }
Index: cpukit/posix/src/mutexunlock.c
===================================================================
--- cpukit/posix/src/mutexunlock.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/mutexunlock.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/posix/muteximpl.h>
+#include <rtems/posix/posixapi.h>
 
 /*
@@ -32,6 +33,6 @@
 {
   POSIX_Mutex_Control  *the_mutex;
-  CORE_mutex_Status     status;
   Thread_queue_Context  queue_context;
+  Status_Control        status;
 
   the_mutex = _POSIX_Mutex_Get( mutex, &queue_context );
@@ -42,4 +43,4 @@
 
   status = _CORE_mutex_Surrender( &the_mutex->Mutex, &queue_context );
-  return _POSIX_Mutex_Translate_core_mutex_return_code( status );
+  return _POSIX_Get_error( status );
 }
Index: cpukit/posix/src/nanosleep.c
===================================================================
--- cpukit/posix/src/nanosleep.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/nanosleep.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -93,6 +93,5 @@
     executing,
     STATES_DELAYING | STATES_INTERRUPTIBLE_BY_SIGNAL,
-    ticks,
-    0
+    ticks
   );
 
Index: cpukit/posix/src/pbarrierwait.c
===================================================================
--- cpukit/posix/src/pbarrierwait.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/pbarrierwait.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,16 +20,7 @@
 
 #include <rtems/posix/barrierimpl.h>
+#include <rtems/posix/posixapi.h>
 
 THREAD_QUEUE_OBJECT_ASSERT( POSIX_Barrier_Control, Barrier.Wait_queue );
-
-/**
- * This directive allows a thread to wait at a barrier.
- *
- * @param[in] barrier is the barrier id
- *
- * @retval 0 if successful
- * @retval PTHREAD_BARRIER_SERIAL_THREAD if successful
- * @retval error_code if unsuccessful
- */
 
 int pthread_barrier_wait(
@@ -39,5 +30,5 @@
   POSIX_Barrier_Control *the_barrier;
   Thread_queue_Context   queue_context;
-  Thread_Control        *executing;
+  Status_Control         status;
 
   if ( barrier == NULL ) {
@@ -51,14 +42,11 @@
   }
 
-  executing = _Thread_Executing;
-  _CORE_barrier_Seize(
+  status = _CORE_barrier_Seize(
     &the_barrier->Barrier,
-    executing,
+    _Thread_Executing,
     true,
-    0,
+    WATCHDOG_NO_TIMEOUT,
     &queue_context
   );
-  return _POSIX_Barrier_Translate_core_barrier_return_code(
-    executing->Wait.return_code
-  );
+  return _POSIX_Get_error( status );
 }
Index: cpukit/posix/src/prwlockrdlock.c
===================================================================
--- cpukit/posix/src/prwlockrdlock.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/prwlockrdlock.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/posix/rwlockimpl.h>
+#include <rtems/posix/posixapi.h>
 
 int pthread_rwlock_rdlock(
@@ -27,5 +28,5 @@
   POSIX_RWLock_Control *the_rwlock;
   Thread_queue_Context  queue_context;
-  Thread_Control       *executing;
+  Status_Control        status;
 
   the_rwlock = _POSIX_RWLock_Get( rwlock, &queue_context );
@@ -35,14 +36,11 @@
   }
 
-  executing = _Thread_Executing;
-  _CORE_RWLock_Seize_for_reading(
+  status = _CORE_RWLock_Seize_for_reading(
     &the_rwlock->RWLock,
-    executing,
+    _Thread_Executing,
     true,                 /* we are willing to wait forever */
     0,
     &queue_context
   );
-  return _POSIX_RWLock_Translate_core_RWLock_return_code(
-    (CORE_RWLock_Status) executing->Wait.return_code
-  );
+  return _POSIX_Get_error( status );
 }
Index: cpukit/posix/src/prwlocktimedrdlock.c
===================================================================
--- cpukit/posix/src/prwlocktimedrdlock.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/prwlocktimedrdlock.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/posix/rwlockimpl.h>
+#include <rtems/posix/posixapi.h>
 #include <rtems/score/todimpl.h>
 
@@ -31,6 +32,6 @@
   Watchdog_Interval                        ticks;
   bool                                     do_wait;
-  TOD_Absolute_timeout_conversion_results  status;
-  Thread_Control                          *executing;
+  TOD_Absolute_timeout_conversion_results  timeout_status;
+  Status_Control                           status;
 
   /*
@@ -40,13 +41,13 @@
    *  So we check the abstime provided, and hold on to whether it
    *  is valid or not.  If it isn't correct and in the future,
-   *  then we do a polling operation and convert the UNSATISFIED
+   *  then we do a polling operation and convert the STATUS_UNAVAILABLE
    *  status into the appropriate error.
    *
-   *  If the status is TOD_ABSOLUTE_TIMEOUT_INVALID,
+   *  If the timeout status is TOD_ABSOLUTE_TIMEOUT_INVALID,
    *  TOD_ABSOLUTE_TIMEOUT_IS_IN_PAST, or TOD_ABSOLUTE_TIMEOUT_IS_NOW,
    *  then we should not wait.
    */
-  status = _TOD_Absolute_timeout_to_ticks( abstime, &ticks );
-  do_wait = ( status == TOD_ABSOLUTE_TIMEOUT_IS_IN_FUTURE );
+  timeout_status = _TOD_Absolute_timeout_to_ticks( abstime, &ticks );
+  do_wait = ( timeout_status == TOD_ABSOLUTE_TIMEOUT_IS_IN_FUTURE );
 
   the_rwlock = _POSIX_RWLock_Get( rwlock, &queue_context );
@@ -56,8 +57,7 @@
   }
 
-  executing = _Thread_Executing;
-  _CORE_RWLock_Seize_for_reading(
+  status = _CORE_RWLock_Seize_for_reading(
     &the_rwlock->RWLock,
-    executing,
+    _Thread_Executing,
     do_wait,
     ticks,
@@ -65,15 +65,12 @@
   );
 
-  if (
-    !do_wait
-      && ( executing->Wait.return_code == CORE_RWLOCK_UNAVAILABLE )
-  ) {
-    if ( status == TOD_ABSOLUTE_TIMEOUT_INVALID ) {
+  if ( !do_wait && status == STATUS_UNAVAILABLE ) {
+    if ( timeout_status == TOD_ABSOLUTE_TIMEOUT_INVALID ) {
       return EINVAL;
     }
 
     if (
-      status == TOD_ABSOLUTE_TIMEOUT_IS_IN_PAST
-        || status == TOD_ABSOLUTE_TIMEOUT_IS_NOW
+      timeout_status == TOD_ABSOLUTE_TIMEOUT_IS_IN_PAST
+        || timeout_status == TOD_ABSOLUTE_TIMEOUT_IS_NOW
     ) {
       return ETIMEDOUT;
@@ -81,6 +78,4 @@
   }
 
-  return _POSIX_RWLock_Translate_core_RWLock_return_code(
-    (CORE_RWLock_Status) executing->Wait.return_code
-  );
+  return _POSIX_Get_error( status );
 }
Index: cpukit/posix/src/prwlocktimedwrlock.c
===================================================================
--- cpukit/posix/src/prwlocktimedwrlock.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/prwlocktimedwrlock.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -22,4 +22,5 @@
 
 #include <rtems/posix/rwlockimpl.h>
+#include <rtems/posix/posixapi.h>
 #include <rtems/score/todimpl.h>
 
@@ -33,6 +34,6 @@
   Watchdog_Interval                        ticks;
   bool                                     do_wait;
-  TOD_Absolute_timeout_conversion_results  status;
-  Thread_Control                          *executing;
+  TOD_Absolute_timeout_conversion_results  timeout_status;
+  Status_Control                           status;
 
   /*
@@ -42,13 +43,13 @@
    *  So we check the abstime provided, and hold on to whether it
    *  is valid or not.  If it isn't correct and in the future,
-   *  then we do a polling operation and convert the UNSATISFIED
+   *  then we do a polling operation and convert the STATUS_UNAVAILABLE
    *  status into the appropriate error.
    *
-   *  If the status is TOD_ABSOLUTE_TIMEOUT_INVALID,
+   *  If the timeout status is TOD_ABSOLUTE_TIMEOUT_INVALID,
    *  TOD_ABSOLUTE_TIMEOUT_IS_IN_PAST, or TOD_ABSOLUTE_TIMEOUT_IS_NOW,
    *  then we should not wait.
    */
-  status = _TOD_Absolute_timeout_to_ticks( abstime, &ticks );
-  do_wait = ( status == TOD_ABSOLUTE_TIMEOUT_IS_IN_FUTURE );
+  timeout_status = _TOD_Absolute_timeout_to_ticks( abstime, &ticks );
+  do_wait = ( timeout_status == TOD_ABSOLUTE_TIMEOUT_IS_IN_FUTURE );
 
   the_rwlock = _POSIX_RWLock_Get( rwlock, &queue_context );
@@ -58,8 +59,7 @@
   }
 
-  executing = _Thread_Executing;
-  _CORE_RWLock_Seize_for_writing(
+  status = _CORE_RWLock_Seize_for_writing(
     &the_rwlock->RWLock,
-    executing,
+    _Thread_Executing,
     do_wait,
     ticks,
@@ -67,15 +67,12 @@
   );
 
-  if (
-    !do_wait
-      && ( executing->Wait.return_code == CORE_RWLOCK_UNAVAILABLE )
-  ) {
-    if ( status == TOD_ABSOLUTE_TIMEOUT_INVALID ) {
+  if ( !do_wait && status == STATUS_UNAVAILABLE ) {
+    if ( timeout_status == TOD_ABSOLUTE_TIMEOUT_INVALID ) {
       return EINVAL;
     }
 
     if (
-      status == TOD_ABSOLUTE_TIMEOUT_IS_IN_PAST
-        || status == TOD_ABSOLUTE_TIMEOUT_IS_NOW
+      timeout_status == TOD_ABSOLUTE_TIMEOUT_IS_IN_PAST
+        || timeout_status == TOD_ABSOLUTE_TIMEOUT_IS_NOW
     ) {
       return ETIMEDOUT;
@@ -83,6 +80,4 @@
   }
 
-  return _POSIX_RWLock_Translate_core_RWLock_return_code(
-    (CORE_RWLock_Status) executing->Wait.return_code
-  );
+  return _POSIX_Get_error( status );
 }
Index: cpukit/posix/src/prwlocktryrdlock.c
===================================================================
--- cpukit/posix/src/prwlocktryrdlock.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/prwlocktryrdlock.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/posix/rwlockimpl.h>
+#include <rtems/posix/posixapi.h>
 
 int pthread_rwlock_tryrdlock(
@@ -27,5 +28,5 @@
   POSIX_RWLock_Control *the_rwlock;
   Thread_queue_Context  queue_context;
-  Thread_Control       *executing;
+  Status_Control        status;
 
   the_rwlock = _POSIX_RWLock_Get( rwlock, &queue_context );
@@ -35,14 +36,11 @@
   }
 
-  executing = _Thread_Executing;
-  _CORE_RWLock_Seize_for_reading(
+  status = _CORE_RWLock_Seize_for_reading(
     &the_rwlock->RWLock,
-    executing,
+    _Thread_Executing,
     false,                  /* do not wait for the rwlock */
     0,
     &queue_context
   );
-  return _POSIX_RWLock_Translate_core_RWLock_return_code(
-    (CORE_RWLock_Status) executing->Wait.return_code
-  );
+  return _POSIX_Get_error( status );
 }
Index: cpukit/posix/src/prwlocktrywrlock.c
===================================================================
--- cpukit/posix/src/prwlocktrywrlock.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/prwlocktrywrlock.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/posix/rwlockimpl.h>
+#include <rtems/posix/posixapi.h>
 
 int pthread_rwlock_trywrlock(
@@ -27,5 +28,5 @@
   POSIX_RWLock_Control *the_rwlock;
   Thread_queue_Context  queue_context;
-  Thread_Control       *executing;
+  Status_Control        status;
 
   the_rwlock = _POSIX_RWLock_Get( rwlock, &queue_context );
@@ -35,14 +36,11 @@
   }
 
-  executing = _Thread_Executing;
-  _CORE_RWLock_Seize_for_writing(
+  status = _CORE_RWLock_Seize_for_writing(
     &the_rwlock->RWLock,
-    executing,
+    _Thread_Executing,
     false,                 /* we are not willing to wait */
     0,
     &queue_context
   );
-  return _POSIX_RWLock_Translate_core_RWLock_return_code(
-    (CORE_RWLock_Status) executing->Wait.return_code
-  );
+  return _POSIX_Get_error( status );
 }
Index: cpukit/posix/src/prwlockunlock.c
===================================================================
--- cpukit/posix/src/prwlockunlock.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/prwlockunlock.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -22,4 +22,5 @@
 
 #include <rtems/posix/rwlockimpl.h>
+#include <rtems/posix/posixapi.h>
 
 int pthread_rwlock_unlock(
@@ -29,5 +30,5 @@
   POSIX_RWLock_Control *the_rwlock;
   Thread_queue_Context  queue_context;
-  CORE_RWLock_Status    status;
+  Status_Control        status;
 
   the_rwlock = _POSIX_RWLock_Get( rwlock, &queue_context );
@@ -38,4 +39,4 @@
 
   status = _CORE_RWLock_Surrender( &the_rwlock->RWLock, &queue_context );
-  return _POSIX_RWLock_Translate_core_RWLock_return_code( status );
+  return _POSIX_Get_error( status );
 }
Index: cpukit/posix/src/prwlockwrlock.c
===================================================================
--- cpukit/posix/src/prwlockwrlock.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/prwlockwrlock.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,8 +21,6 @@
 #endif
 
-#include <pthread.h>
-#include <errno.h>
-
 #include <rtems/posix/rwlockimpl.h>
+#include <rtems/posix/posixapi.h>
 
 THREAD_QUEUE_OBJECT_ASSERT( POSIX_RWLock_Control, RWLock.Wait_queue );
@@ -34,5 +32,5 @@
   POSIX_RWLock_Control *the_rwlock;
   Thread_queue_Context  queue_context;
-  Thread_Control       *executing;
+  Status_Control        status;
 
   the_rwlock = _POSIX_RWLock_Get( rwlock, &queue_context );
@@ -42,14 +40,11 @@
   }
 
-  executing = _Thread_Executing;
-  _CORE_RWLock_Seize_for_writing(
+  status = _CORE_RWLock_Seize_for_writing(
     &the_rwlock->RWLock,
-    executing,
+    _Thread_Executing,
     true,          /* do not timeout -- wait forever */
     0,
     &queue_context
   );
-  return _POSIX_RWLock_Translate_core_RWLock_return_code(
-    (CORE_RWLock_Status) executing->Wait.return_code
-  );
+  return _POSIX_Get_error( status );
 }
Index: cpukit/posix/src/psignalunblockthread.c
===================================================================
--- cpukit/posix/src/psignalunblockthread.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/psignalunblockthread.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -99,5 +99,5 @@
   POSIX_API_Control  *api;
   int                 signo;
-  int                 hold_errno;
+  uint32_t            hold_errno;
 
   (void) action;
@@ -199,5 +199,5 @@
 
     if ( (the_thread->Wait.option & mask) || (api->signals_unblocked & mask) ) {
-      the_thread->Wait.return_code = EINTR;
+      the_thread->Wait.return_code = STATUS_INTERRUPTED;
 
       the_info = (siginfo_t *) the_thread->Wait.return_argument;
@@ -241,5 +241,5 @@
 
     if ( _States_Is_interruptible_by_signal( the_thread->current_state ) ) {
-      the_thread->Wait.return_code = EINTR;
+      the_thread->Wait.return_code = STATUS_INTERRUPTED;
       _Thread_queue_Extract_with_proxy( the_thread );
     }
